-------------------------------------------------------------------
-------------------------------------------------------------------
-- Title:           Holic Bot                                    --
-- Author:          Elverion                                     --
-- Date:            Oct. 13, 2008                                --
-- Requirements:    MicroMacro v0.98                             --
-- License:         Public Domain                                --
-------------------------------------------------------------------
-------------------------------------------------------------------
-- This script is public domain. You may use it in any way you   --
-- find appropriate without restriction. This includes, but is   --
-- not limited to, modification and distribution, whether it be  --
-- commercial or not.                                            --
-------------------------------------------------------------------
-------------------------------------------------------------------

-- Helper function to be registered (temporarily) by fight logic
function __attack()
  keyboardPress(KEY_ATTACK);
end


-- check if we can use any of our skills, and attempt to do so
-- if we can.
-- we break after each skill we cast so that our fighting
-- logic can be run as well, rather than spam skills without
-- full logic support.

function __checkSkills()
  for i = 1, #skillList do
    if( skillList[i]:canUse() ) then
      skillList[i]:cast();
      return;
    else
    end
  end
end


function fight()
  PlayerInCombat = true;
  __attack();
  printf("Begining attack on monster 0x%X\n", Target);
  registerTimer("TEMP_ATTACK", secondsToTimer(1), __attack);

  local startTime = os.time();
  local tempSkipLoot = false; -- if we are unable to kill the monster, we'll skip looting just once.

  local targetLastHP = TargetHP; -- keep track of target's HP change.
  local targetLastHPChange = os.time();

  while( haveTarget() ) do
    if( needHeal() ) then
      useHPPotion();
    elseif( needMana() ) then
      useMPPotion();
    end

    if( targetHP ~= targetLastHPChange ) then
      targetLastHPChange = os.time();
      targetLastHP = TargetHP;
    end

    if( (os.difftime(os.time(), startTime) > ignoreTime) and (os.difftime(os.time(), targetLastHPChange) > 10) ) then
      -- we've been fighting this monster for too long...
      -- we're probably stuck, so ignore this monster.
      -- if we're wrong, we'll retarget it and continue fighting.

      printf("Stuck trying to reach target. Ignoring.\n");
      clearTarget();
      __moveBack();
      tempSkipLoot = true;
      startTime = os.time(); -- so we don't constantly try to back away and refuse to fight.
    end

    __checkSkills();

    yrest(100);
  end

  unregisterTimer("TEMP_ATTACK");

  printf("Target died.\n");
  yrest(750); -- pause before doing anything

  if( skipLooting == false  and tempSkipLoot == false ) then
    pickup();
  end

  PlayerInCombat = false;
end


-- attempt to pickup nearby item
function pickup()
  keyboardPress(KEY_PICKUP);
  yrest(100);

  local startX, startY = PlayerX, PlayerY;
  local startTime = os.time();
  local lastMoved = os.time();

  while( true ) do
    keyboardPress(KEY_PICKUP);
    yrest(100);

    if( math.floor(startX) ~= math.floor(PlayerX) and math.floor(startY) ~= math.floor(PlayerY) ) then
      lastMoved = os.time();
    end

    if( os.difftime(os.time(), lastMoved) > 1 ) then
      printf("Stopped moving. Exiting loot sequence.\n");
      return;
    end

    if( haveTarget() ) then
      printf("Pulled aggro. Exiting loot sequence.\n");
      return;
    end

    if( os.difftime(os.time(), startTime) > 4 ) then
      printf("Spending too much time looting. Breaking loot sequence.\n");
      return;
    end

    startX, startY = PlayerX, PlayerY;
  end
end


-- If we get stuck, we'll take a few steps back
function __moveBack()
  printf("Backing away from monster...\n");
  local startTime = os.time();

  keyboardHold(KEY_MOVEBACKWARD);
  while( os.difftime(os.time(), startTime) < 5 ) do
    yrest(100);
  end
  keyboardRelease(KEY_MOVEBACKWARD);

  yrest(200);

  -- if this monster isn't trying to kill us, we'll try
  -- walking around the obstruction. otherwise, try fighting
  -- back.
  if( not haveTarget() ) then
    constructUnstuckPath();
  end
end