-------------------------------------------------------------------
-------------------------------------------------------------------
-- Title:           Holic Bot                                    --
-- Author:          Elverion                                     --
-- Date:            Oct. 13, 2008                                --
-- Requirements:    MicroMacro v0.98                             --
-- License:         Public Domain                                --
-------------------------------------------------------------------
-------------------------------------------------------------------
-- This script is public domain. You may use it in any way you   --
-- find appropriate without restriction. This includes, but is   --
-- not limited to, modification and distribution, whether it be  --
-- commercial or not.                                            --
-------------------------------------------------------------------
-------------------------------------------------------------------

include("base.lua");
include("skills_base.lua");
include("functions.lua");
include("hotkeys.lua");
include("logic.lua");
include("options.lua");


SCRIPT_VERSION = 1.0;


mouseSetDelay(100);
keyboardSetDelay(100);
setPriority(priority.high);

antiKSTriggerCount = 0; -- Number of times in a row we triggered anti-KS.
                        -- If too high, we temporarily stop auto-targeting

function main()
  cprintf(cli.green, "Holic Bot v%0.2f\n", SCRIPT_VERSION);
  logMessage(sprintf("Holic Bot, version %0.2f\n", SCRIPT_VERSION));

  win = getSelectedWindow();
  proc = openProcess(findProcessByWindow(win));
  atPause(pauseCallback);
  atResume(resumeCallback);

  updateVars(); -- do a manual update now
  registerTimer("updateVars", secondsToTimer(0.10), updateVars);

  initMovementSystem(); -- we need to make sure we updateVars() *BEFORE* calling this!

  if( not getTargetPtr(proc) ) then
    error("Error looking up target pointer... Are you sure you have Holic targetted?\n", 0);
  end

  local lastLevel = PlayerLevel;
  while(true) do
    __checkSkills();

    if( isPlayerDead() ) then
      printf("Died. Stopping bot.\n");
      stopPE();
    end

    if( lastLevel ~= PlayerLevel ) then
      printf("WOOHOO! You leveled up!\n");
      lastLevel = PlayerLevel;
    end

    if( needHeal() ) then
      useHPPotion();
    elseif( needMana() ) then
      useMPPotion();
    end

    if( haveTarget() ) then
      -- attack!
      fight();
    else
      continueWaypointPath();
      printf("Waypoint complete.\n");
    end
    
    yrest(100);
  end
  
end
startMacro(main);