-------------------------------------------------------------------
-------------------------------------------------------------------
-- Title:           Holic Bot                                    --
-- Author:          Elverion                                     --
-- Date:            Oct. 13, 2008                                --
-- Requirements:    MicroMacro v0.98                             --
-- License:         Public Domain                                --
-------------------------------------------------------------------
-------------------------------------------------------------------
-- This script is public domain. You may use it in any way you   --
-- find appropriate without restriction. This includes, but is   --
-- not limited to, modification and distribution, whether it be  --
-- commercial or not.                                            --
-------------------------------------------------------------------
-------------------------------------------------------------------

-- Seeing as this is just random wandering, it does not actually have waypoints.
-- However, we still implement the system for ease of use.



function continueWaypointPath()
  if( current_wpx == nil ) then current_wpx = PlayerX; end
  if( current_wpy == nil ) then current_wpy = PlayerY; end;

  local waypointSuccess = true;

  if( #waypointQueue > 0 ) then
    -- we have waypoints in the queue... follow them.

    current_wpx = waypointQueue[1].x; current_wpy = waypointQueue[1].y;
    waypointSuccess = stepTowardsWaypoint(current_wpx, current_wpy, true);
    table.remove(waypointQueue, 1);

    -- we failed...drop waypoints.
    if( not waypointSuccess ) then
      for i = 1,#waypointQueue do
        table.remove(waypointQueue);
      end
    end

    return;
  end

  if( distance(PlayerX, PlayerY, WANDER_STARTX, WANDER_STARTY) > wanderRadius ) then
    -- We're going a bit too far... let's turn back
    printf("Woops, we went a bit off-course. Turning around...\n");
    current_wpx = WANDER_STARTX; current_wpy = WANDER_STARTY; 
    waypointSuccess = stepTowardsWaypoint(WANDER_STARTX, WANDER_STARTY, true);

    if( not waypointSuccess ) then
      constructUnstuckPath();
    end

    return;
  end

  if( PlayerX == nil ) then printf("PlayerX nil\n"); end
  if( current_wpx == nil ) then printf("current_wpx is nil\n"); end

  if( distance(PlayerX, PlayerY, current_wpx, current_wpy) > 5 ) then
    -- we haven't reached our current waypoint... so continue it!
    waypointSuccess = stepTowardsWaypoint(current_wpx, current_wpy);

    if( not waypointSuccess ) then
      constructUnstuckPath();
    end

    return;
  end

  -- apparently we don't have a new waypoint at this time, so let's make one up!
  current_wpx = WANDER_STARTX + math.random(wanderRadius) - wanderRadius/2;
  current_wpy = WANDER_STARTY + math.random(wanderRadius) - wanderRadius/2;

  printf("Target waypoint: (%d,%d)\n", current_wpx, current_wpy);
  waypointSuccess = stepTowardsWaypoint(current_wpx, current_wpy);

  if( not waypointSuccess ) then
    constructUnstuckPath();
  end

end
